type PrintWriter = {
    def close: ()
    def flush: ()
    def write(x: int): ()
    def writeString(str: string): ()
}

newtype PrintWriterModule = {
    def create(funneloutstream: OutputStream): PrintWriter
    def new(javawriter: any): PrintWriter
}

let PrintWriter: PrintWriterModule = {
    def create(stream) = {
	new (primitive (0, "java.io.PrintWriter", "<init>", "(Ljava/io/OutputStream;)V")
	               (stream.toJava))
    }
    def new(writer) = {
        def close = primitive (2, "java.io.PrintWriter", "close", "()V") (writer)
        def flush = primitive (2, "java.io.PrintWriter", "flush", "()V") (writer)
        def write (x: int) =
	    primitive (2, "java.io.PrintWriter", "write", "(I)V") (writer, x)
        def writeString (str: string) = 
	    primitive (2, "java.io.PrintWriter", "write", "(Ljava/lang/String;)V")
	    (writer, str)
    }
}
